%define anolis_release 4

%define install_prefix /opt/tongsuo

%global _privatelibs libcrypto[.]so.*
%global _privatelibs %{_privatelibs}|libssl[.]so.*
%global __provides_exclude ^(%{_privatelibs})$
%global __requires_exclude ^(%{_privatelibs})$

%global DOMAIN github.com
%global ORG BabaSSL
%global PROJECT BabaSSL
%global IMPORTNAME %{DOMAIN}/%{ORG}/%{PROJECT}

Name:           tongsuo
Version:        8.3.3
Release:        %{anolis_release}%{?dist}
Summary:        A Modern Cryptographic Primitives and Protocols Library
Group:          System Environment/Libraries
License:        Apache-2.0
Url:            https://www.yuque.com/tsdoc
Source0:        https://github.com/Tongsuo-Project/Tongsuo/archive/%{version}/Tongsuo-%{version}.tar.gz
Patch001:	0001-add-loongarch64-support-for-tongsuo.patch

# For build
BuildRequires:  perl(Config)
BuildRequires:  perl(File::Basename)
BuildRequires:  perl(File::Path)
BuildRequires:  perl(File::Spec::Functions)
BuildRequires:  perl(FindBin)
BuildRequires:  perl(File::Copy)
BuildRequires:  perl(File::Compare)
BuildRequires:  perl(lib)
BuildRequires:  /usr/bin/pod2html
# For tests
BuildRequires:  perl(TAP::Harness)
BuildRequires:  perl(Test::More)
Obsoletes:      babassl < %{version}
Provides:       babassl = %{version}

%description
A Modern Cryptographic Primitives and Protocols Library.

%prep
%autosetup -n Tongsuo-%{version} -p1

%build
sslarch=%{_os}-%{_target_cpu}

%ifarch %ix86
sslarch=linux-x86
%endif
%ifarch x86_64
sslarch=linux-x86_64
%endif
%ifarch aarch64
sslarch=linux-aarch64
%endif
%ifarch longarch64
sslarch=linux-loongarch64
%endif

./Configure \
    --prefix=%{install_prefix} -Wl,-rpath,%{install_prefix}/lib \
    ${sslarch} enable-shared no-hw no-hw-padlock no-static-engine \
    enable-dynamic-engine enable-tls1_3 enable-ssl3 enable-ssl3-method \
    enable-weak-ssl-ciphers enable-evp-cipher-api-compat enable-status \
    enable-crypto-mdebug-count enable-dynamic-ciphers enable-optimize-chacha \
    enable-rsa-multi-prime-key-compat enable-session-lookup \
    enable-session-reused-type enable-global-session-cache enable-verify-sni \
    enable-skip-scsv enable-ntls enable-sm2 \
    %{build_cflags} %{build_ldflags}

%make_build

%check
%make_build test

%install
%make_install

rm -f %{buildroot}%{install_prefix}{/bin/c_rehash,/ssl/misc/tsget*,/ssl/misc/*.pl}

export QA_RPATHS=$(( 0x0002 ))

%files
%license LICENSE
%{install_prefix}
%dir %{install_prefix}

%changelog
* Wed May 22 2024 mgb01105731 <mgb01105731@alibaba-inc.com> - 8.3.3-4
- fix source link

* Tue Nov 21 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 8.3.3-3
- modify the spec to support loongarch64

* Tue Nov 21 2023 Wenlong Zhang<zhangwenlong@loongson.cn> - 8.3.3-2
- add loongarch64 support for tongsuo

* Mon Aug 28 2023 Tianjia Zhang <tianjia.zhang@linux.alibaba.com> - 8.3.3-1
- Introduce v8.3.3

* Sun Aug 27 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 8.3.2-2
- backport patches from 8.3-stable

* Tue Feb 14 2023 Funda Wang <fundawang@yeah.net> - 8.3.2-1
- Import packge for anolis 23
